<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 22/04/2015
 * Time: 17:14
 */

namespace Service\Calendar\Restriction\Strategy;


use Service\Calendar\TaskCalendar;

class AsSoonAsPossible extends  RestrictionStrategyAbstract{

    /**
     * @param $setAllocation
     * @return array
     */
    public function getDatesBeginAndEnd($setAllocation = true)
    {

        if($this->task->needScheduleCalcDates()){
            $beginTask = clone $this->task->getEstimatedBeginDate();
            $endTask = clone $this->task->getEstimatedEndDate();
            $taskParent = $this->task->getTreeParent();
            if(!empty($taskParent)&& $taskParent->usesDataControl()){
                list($beginTask, $dateEnd) = $this->taskCalendar->getDatesBeginAndEnd($taskParent,$setAllocation);
            }
            $beginTask = $this->getDatesByPrecursor($beginTask,$endTask,$setAllocation);
            $beginTaskFinal =  $this->taskCalendar->getEndDateByCalendar($this->task, clone $beginTask,  false,
                $this->task->getLatency()+$this->task->getPreviousTime(), true);
            $endTask = $this->taskCalendar->getDateEnd($this->task, clone $beginTask, $setAllocation);
        }else{
            $beginTaskFinal = clone $this->task->getEstimatedBeginDate();
            $endTask = clone $this->task->getEstimatedEndDate();
        }

        return array($beginTaskFinal,$endTask);
    }

    public function getDatesByPrecursor($beginTask,$endTask,$setAllocation = true)
    {
        if(!$this->task->isContainer()) {
            $datePrecursors = $this->taskCalendar->getDatesPrecursors($this->task, $setAllocation);
            if (!empty($datePrecursors)) {
                foreach ($datePrecursors as $datePrecursor) {
                    list($dateBegin, $dateEnd) = $datePrecursor;
                    if ($dateBegin > $beginTask) {
                        $beginTask = $dateBegin;
                    }
                }
            }
        }
        return $beginTask;
    }

    public function getDatesMinAndMax($dateBeginMax,$dateEndMin)
    {
        return array($dateBeginMax,$dateEndMin);
    }
}